#include "dataset.h" 

#include <fstream> 
#include <iostream>

void DataSet::load(string& name) {
  
  ifstream fin(name.c_str());

  int N;
  int m,n,nam; 

  TrainSample buf;

  fin >> N;  // # of data points
  fin >> nam;
  fin >> n;  // # of inputs  (i.e. dim of input vector)
  fin >> m;  // # of outputs (i.e. dim of output vector) 

  buf.input.resize(n); 
  buf.output.resize(m); 

  min.input.resize(n); min.output.resize(m);
  max.input.resize(n); max.output.resize(m);

  data.resize(N);

  // read the first sample
  for (int j=0; j<n; j++) {
    fin >> buf.input[j]; 
    min.input[j] = buf.input[j]; 
    max.input[j] = buf.input[j]; 
  }
  for (int j=0; j<m; j++) {
    fin >> buf.output[j]; 
    min.output[j] = buf.output[j]; 
    max.output[j] = buf.output[j]; 
  }
  data[0] = buf;

  // read the rest 
  for (int i=1; i<N; i++) {
    
    for (int j=0; j<n; j++) {
      fin >> buf.input[j]; 
      if (buf.input[j] < min.input[j]) min.input[j] = buf.input[j]; 
      if (buf.input[j] > max.input[j]) max.input[j] = buf.input[j]; 
    }
    
    for (int j=0; j<m; j++) {
      fin >> buf.output[j]; 
      if (buf.output[j] < min.output[j]) min.output[j] = buf.output[j]; 
      if (buf.output[j] > max.output[j]) max.output[j] = buf.output[j]; 
    }

    data[i] = buf; 
  } 

  fin.close();
} 

void DataSet::save(string& name) {
  // not implemented yet
} 

void DataSet::print() {
  cout << data.size() << endl; 
  cout << data[0].getN() + data[0].getM() << endl; 
  cout << data[0].getN() << endl; 
  cout << data[0].getM() << endl; 
  for (unsigned i=0; i<data.size(); i++) {
    for (int j=0; j<data[i].getN(); j++) 
      cout << data[i].input[j] << " "; 
    //    cout << "| "; 
    for (int j=0; j<data[i].getM(); j++) 
      cout << data[i].output[j] << " "; 
    cout << endl; 
  }
} 
